* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
/ Input an arbint.
/ Convert a string of signed digits into an arbint.
/ Hex and octal prefixes are allowed.
include <ctype.h>
include <error.h>
include <arbint.h>
include <debug.h>	// DELETE

onst int chunksize = 5;

/ convert hexadecimal 0-9, a-f, A-F
/ to its numeric value
nline int hexvalue(char c)

   if (isdigit(c))
return c - '0';
   else if (c >= 'a' && c <= 'f')
return c - 'a' + 10;
   else
return c - 'A' + 10;


/ return true if c is an octal digit
nline int isodigit(int c)

   return isdigit(c) && c < '8';


tatic ARB_type *i_s;
tatic i_len;

*
   Add to the length of i_s by allocated new space,
   copying the old data to the new space, and
   deleting the old space. The new space is initialized
   to all zeros, except for the last digit whose value
   is passed in.
/
tatic void extend_s(int k)

   int olen = i_len;
   i_len += chunksize;

   ARB_type *new_i_s = new ARB_type[i_len];
   memcpy((char*)&new_i_s[chunksize], (char*)i_s,
i_len * sizeof(ARB_type));

   memset((char*)new_i_s, 0, 4);
   new_i_s[4] = k;

   delete i_s;
   i_s = new_i_s;


/ perform: i = i * base - newdigit
tatic void addonedigit(int multiplier, int addend)

   // i *= base
   // almost identical to that used
   // for operator*
   ARB_Ltype k = 0;
   for (int l = i_len - 1; l >= 0; l--)
{
ARB_Ltype t = i_s[l] * multiplier + k;
i_s[l] = t;	// % ARB_base
k = t / ARB_base;
}

   // add digits, if necessary
   if ((k != 0) || (i_s[0] & 0x8000))
extend_s(k);

   // i += addend
   // almost identical to that used
   // for operator+
   k = addend;
   for (l = i_len - 1; l >= 0; l--)
{d	ARB_Ltype t = i_s[l] + k;
i_s[l] = t;
k = (t / ARB_base) ? 1 : 0;
}

   // add digits, if necessary
   if ((k != 0) || (i_s[0] & 0x8000))
extend_s(k);


stream& operator>> (istream& in, arbint& i)

   char c, sign = 0;
   in >> WS;		// skip white space
   if (!in.get(c))
{
i = 0L;
return in;
}

   switch (c)		// remember the sign
{
case '+': case '-':
    sign = c;
    if (!in.get(c))
	{
	i = 0L;
	return in;
	}
    break;
}

   // allocate the initial data space
   i_s = new ARB_type[chunksize];
   i_len = chunksize;
   memset((char*)i_s, 0, chunksize * sizeof(ARB_type));

   switch (c)
{
case '0':		// hex or octal
    if (!in.get(c))
	break;

    switch (c)
	{
	case 'x':		// hex number
	case 'X':
	    for (in.get(c);
		 in && isxdigit(c);
		 in.get(c))
		addonedigit(16, hexvalue(c));
	    break;

	default:		// octal number
	    for ( ;
		 in && isodigit(c);
		 in.get(c))
		addonedigit(8, (c - '0'));
	    break;
	}
    break;

default:		// decimal number
    for ( ; in && isdigit(c); in.get(c))
	addonedigit(10, (c - '0'));
    break;
}

   if (in)
in.putback(c);

   // change sign, if necessary,
   // and save datad
bug&1)    outputarb(cerr, "\n\nin:\ni_s=", i_s, i_len);		// DELETEd    arbint ret(i_s, i_len);
f (debug&1)    outputarb(cerr, "ret=", ret.p->value, ret.p->length);		// DELETE
   if (sign == '-')
i = -ret;
   else
i = ret;d
bug&1)    outputarb(cerr, "i=", i.p->value, i.p->length);		// DELETE

   return in;

